﻿Type=Service
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False	
#End Region

Sub Process_Globals

	Private notif As Notification
	
End Sub


Sub Service_Create

	notif.Initialize
	notif.OnGoingEvent = True
	notif.Sound = False
	notif.Vibrate = False
	notif.Light = False
	notif.Vibrate = False
	notif.AutoCancel = False
	notif.Icon = "icon"
	notif.SetInfo(Application.LabelName, "Test...", Main)
	notif.Notify(1)
	Service.StartForeground(1, notif) ' StartForeground so stream can work in background :)
		
	Dim jo As JavaObject
	jo =  jo.InitializeStatic("com.spoledge.aacdecoder.PlayerCallback") ' initialize PlayerCallback
	Dim PlayerCallback As Object = jo.CreateEvent("com.spoledge.aacdecoder.PlayerCallback", "PlayerCallback", Null) ' Set PlayerCallback
	modGlobal.AacMp3Player = jo.InitializeNewInstance("com.spoledge.aacdecoder.MultiPlayer", Array As Object(PlayerCallback)) ' Set MultiPlayer (AAC + MPEG/MP3 decode)
	modGlobal.AacMp3Player.RunMethod("setMetadataCharEnc", Array("ISO-8859-1")) ' 99% of radio station use Western charset, if you comment this line UTF-8 will be used
																				' char set options: ISO-8859-1, US-ASCII, UTF-8, UTF-16, UTF-16BE, UTF-16LE 		
End Sub


Sub Service_Start (StartingIntent As Intent)
	
End Sub


Sub PlayerCallback_Event (MethodName As String, Args() As Object) As Object 'ignore

	'Log(MethodName)
	  
  	If MethodName = "playerMetadata" Then	
'		If Args(0) <> Null And Args(1) <> Null Then 'uncomment to see all posible arguments for radio station
'			Log (Args(0) & ": " & Args(1))
'		End If			
		Try
			If Args(0) <> Null And Args(1) <> Null And Args(0) = "icy-name" Then
				CallSubDelayed2(Main, "Station", Args(1)) ' set station name on lblStationName on Main Activity
			End If							
		Catch
			Log("PlayerCallback_Event - playerMetadata(1): " & LastException)
		End Try
		
		Try
			If Args(0) <> Null And Args(1) <> Null And Args(0) = "StreamTitle" Then
				CallSubDelayed2(Main, "Song", Args(1)) ' set song name on lblSongName on Main Activity				
			End If							
		Catch
			Log("PlayerCallback_Event - playerMetadata(2): " & LastException)
		End Try		
	End If
		
	If MethodName = "playerStarted" Then ' Player START playing
		modGlobal.PlayerStarted = True
		CallSubDelayed(Main, "Start")
	End If
		
	If MethodName = "playerStopped" Then ' Player STOP playing
		modGlobal.PlayerStarted = False	
		CallSubDelayed(Main, "Stop")
	End If	 
	
	If MethodName = "playerException" Then ' Player EXCEPTION, check LOG for errors
		modGlobal.PlayerStarted = False
		CallSubDelayed(Main, "Stop")
		Try		
			If Args(0) <> Null Then	
				Log ("PlayerCallback_Event - playerException(1): " & Args(0)) ' if something go wrong, you can see in LOG what is wrong
			End If
		Catch
			Log ("PlayerCallback_Event - playerException(2): " & LastException)			
		End Try
	
	End If

End Sub


Sub Service_Destroy

End Sub
